/*** field2n.h ***/

#define WORDSIZE	(sizeof(int)*8)
#define NUMBITS		0x81             //order

#define	NUMWORD		(NUMBITS/WORDSIZE)
#define UPRSHIFT	(NUMBITS%WORDSIZE)

#define MAXLONG		(NUMWORD+1)

#define MAXBITS		(MAXLONG*WORDSIZE)
#define MAXSHIFT	(WORDSIZE-1)
#define MSB			(1L<<MAXSHIFT)

#define UPRBIT		(1L<<(UPRSHIFT-1))
#define UPRMASK		(~(-1L<<UPRSHIFT))
#define SUMLOOP(i)	for(i=0; i<MAXLONG; i++)

typedef	short int INDEX;

typedef unsigned long ELEMENT;


typedef struct {
	ELEMENT 	e[MAXLONG];
}  FIELD2N;