//declaration
/*
void encrypt(DWORD *,DWORD *,BYTE,BYTE);
void decrypt(DWORD *,DWORD *);

void en_step1(DWORD *,DWORD *);
void en_step2(DWORD *);
void en_step3(DWORD *);
void en_step4(DWORD *);

void de_step1(DWORD *,DWORD *);
void de_step2(DWORD *);
void de_step3(DWORD *);
void de_step4(DWORD *);

DWORD ror(DWORD x,int y);
DWORD rol(DWORD x,int y);
*/
DWORD ror(DWORD x,int y)
{int i;
 DWORD temp1,temp2;
		i=y%32;
		i=32-i;
		temp1=x;
		temp2=x;
		temp1=temp1>>y;
		temp2=temp2<<i;
		temp1=temp1|temp2;
 return temp1; 
}
DWORD rol(DWORD x,int y)
{int i;
 DWORD temp1,temp2;
		i=y%32;
		i=32-i;
		temp1=x;
		temp2=x;
		temp1=temp1<<y;
		temp2=temp2>>i;
		temp1=temp1|temp2;
 return temp1; 
}
//encrypt routine
void en_step1(DWORD * temp,DWORD * src)
{DWORD temp1,temp2;
	temp1=src[0]^src[2];
	src[1]=src[1]^ror(temp1,8)^rol(temp1,8)^temp1;
	src[3]=src[3]^ror(temp1,8)^rol(temp1,8)^temp1;
	src[0]=src[0]^temp[0];
	src[1]=src[1]^temp[1];
	src[2]=src[2]^temp[2];
	src[3]=src[3]^temp[3];
	temp2=src[1]^src[3];
	src[0]=src[0]^ror(temp2,8)^rol(temp2,8)^temp2;
	src[2]=src[2]^ror(temp2,8)^rol(temp2,8)^temp2;
}
void en_step2(DWORD * src)
{
	src[1]=rol(src[1],1);
	src[2]=rol(src[2],5);
	src[3]=rol(src[3],2);
}
void en_step3(DWORD * src)
{DWORD temp;
	temp  =src[3];
	src[1]=src[1]^((~src[2])&(~temp));
	src[0]=src[0]^(src[1]&src[2]);
	src[3]=src[0];
	src[2]=src[2]^src[1]^src[0]^temp;
	src[1]=src[1]^((~src[2])&(~src[0]));
	src[0]=temp^(src[1]&src[2]);
}
void en_step4(DWORD * src)
{
	src[1]=ror(src[1],1);
	src[2]=ror(src[2],5);
	src[3]=ror(src[3],2);
}

void encrypt(DWORD * key,DWORD * src,BYTE counter,BYTE const_0)
{int i;
 DWORD temp;
 for(i=0;i<0x10;i++)	
{	src[0]=src[0]^counter;
	en_step1(key,src);
	en_step2(src);
	en_step3(src);
	en_step4(src);
	if((counter&0x80)==0) 
		_asm shl counter,1	
	else 
		_asm
		    {
			mov al,counter
			shl al,1
			xor al,1Bh
			mov counter,al
		    }
}
 temp=(DWORD)counter;
 src[0]=src[0]^temp;
 en_step1(key,src);
}
//decrypt routine
void de_step4(DWORD * src)
{
	src[1]=rol(src[1],1);
	src[2]=rol(src[2],5);
	src[3]=rol(src[3],2);
}
void de_step3(DWORD * src)
{DWORD  temp1,temp2;
	temp1=src[3];
	src[3]=src[0]^(src[1]&src[2]);
	temp2=src[1]^((~src[2])&(~temp1));
	src[2]=src[2]^temp1^temp2^src[3];
	src[0]=temp1^(temp2&src[2]);
	src[1]=temp2^((~src[2])&(~src[3]));
}
void de_step2(DWORD * src)
{
	src[1]=ror(src[1],1);
	src[2]=ror(src[2],5);
	src[3]=ror(src[3],2);
}
void de_step1(DWORD * temp,DWORD * src)
{DWORD temp1,temp2;
	temp2=src[1]^src[3];
	src[0]=src[0]^ror(temp2,8)^rol(temp2,8)^temp2;
	src[2]=src[2]^ror(temp2,8)^rol(temp2,8)^temp2;
	src[0]=src[0]^temp[0];
	src[1]=src[1]^temp[1];
	src[2]=src[2]^temp[2];
	src[3]=src[3]^temp[3];
	temp1=src[0]^src[2];
	src[1]=src[1]^ror(temp1,8)^rol(temp1,8)^temp1;
	src[3]=src[3]^ror(temp1,8)^rol(temp1,8)^temp1;
}
void decrypt(DWORD * key,DWORD * src)
{int i,temp;
 BYTE j,k;
 BYTE counter[0x11]={0x80};
 for(i=0;i<0x11;i++)
	{   j=counter[i];
	 if((counter[i]&0x80)==0) 
		__asm {	
			mov al,j
		 	shl al,1
		 	mov k,al	
		      } 
	else 
		__asm
		    {
			mov al,j
			shl al,1
			xor al,1Bh
			mov k,al
		    }
		counter[i+1]=k;
	}
 temp=(DWORD)counter[0x10];
 de_step1(key,src);
 src[0]=src[0]^temp;
 for(i=0;i<0x10;i++)
	{
	de_step4(src); 
	de_step3(src);
	de_step2(src);
	de_step1(key,src);
	src[0]=src[0]^counter[0xF-i];
	}
	
}

void convert_1(unsigned char * src,DWORD * dest)
{	
	__asm
		{	mov esi,src[0]
			mov edi,dest[0]
			xor eax,eax
			movzx eax,byte ptr [esi]
			shl eax,8
			movzx ebx,byte ptr [esi+1]
			or  eax,ebx
			shl eax,8
			movzx ebx,byte ptr [esi+2]
			or  eax,ebx
			shl eax,8
			movzx ebx,byte ptr [esi+3]
			or  eax,ebx
			mov dword ptr [edi],eax  ;dest[0]
			xor eax,eax
			movzx eax,byte ptr [esi+4]
			shl eax,8
			movzx ebx,byte ptr [esi+5]
			or  eax,ebx
			shl eax,8
			movzx ebx,byte ptr [esi+6]
			or  eax,ebx
			shl eax,8
			movzx ebx,byte ptr [esi+7]
			or  eax,ebx
			mov dword ptr [edi+4],eax ;dest[1]
			xor eax,eax
			movzx eax,byte ptr [esi+8]
			shl eax,8
			movzx ebx,byte ptr [esi+9]
			or  eax,ebx
			shl eax,8
			movzx ebx,byte ptr [esi+0xA]
			or  eax,ebx
			shl eax,8
			movzx ebx,byte ptr [esi+0xB]
			or  eax,ebx
			mov dword ptr [edi+8],eax   ;dest[2]
			xor eax,eax
			movzx eax,byte ptr [esi+0xC]
			shl eax,8
			movzx ebx,byte ptr [esi+0xD]
			or  eax,ebx
			shl eax,8
			movzx ebx,byte ptr [esi+0xE]
			or  eax,ebx
			shl eax,8
			movzx ebx,byte ptr [esi+0xF]
			or  eax,ebx
			mov dword ptr [edi+0xC],eax   ;dest[3]
		}
}

void convert_2(unsigned char * dest,DWORD * src)
{	
	__asm
		{	mov esi,src[0]
			mov edi,dest[0]
			mov eax,dword ptr [esi]
			mov BYTE ptr [edi+3],al
			shr eax,8
			mov BYTE ptr [edi+2],al
			shr eax,8
			mov BYTE ptr [edi+1],al
			shr eax,8
			mov BYTE ptr [edi+0],al
			mov eax,dword ptr [esi+4]
			mov BYTE ptr [edi+7],al
			shr eax,8
			mov BYTE ptr [edi+6],al
			shr eax,8
			mov BYTE ptr [edi+5],al
			shr eax,8
			mov BYTE ptr [edi+4],al
			mov eax,dword ptr [esi+8]
			mov BYTE ptr [edi+0xB],al
			shr eax,8
			mov BYTE ptr [edi+0xA],al
			shr eax,8
			mov BYTE ptr [edi+9],al
			shr eax,8
			mov BYTE ptr [edi+8],al
			mov eax,dword ptr [esi+0xC]
			mov BYTE ptr [edi+0xF],al
			shr eax,8
			mov BYTE ptr [edi+0xE],al
			shr eax,8
			mov BYTE ptr [edi+0xD],al
			shr eax,8
			mov BYTE ptr [edi+0xC],al
		}
}
